Mercurial > libervia-backend
annotate docker/pubsub/entrypoint.sh @ 4231:e11b13418ba6
plugin XEP-0353, XEP-0234, jingle: WebRTC data channel signaling implementation:
Implement XEP-0343: Signaling WebRTC Data Channels in Jingle. The current version of the
XEP (0.3.1) has no implementation and contains some flaws. After discussing this on xsf@,
Daniel (from Conversations) mentioned that they had a sprint with Larma (from Dino) to
work on another version and provided me with this link:
https://gist.github.com/iNPUTmice/6c56f3e948cca517c5fb129016d99e74 . I have used it for my
implementation.
This implementation reuses work done on Jingle A/V call (notably XEP-0176 and XEP-0167
plugins), with adaptations. When used, XEP-0234 will not handle the file itself as it
normally does. This is because WebRTC has several implementations (browser for web
interface, GStreamer for others), and file/data must be handled directly by the frontend.
This is particularly important for web frontends, as the file is not sent from the backend
but from the end-user's browser device.
Among the changes, there are:
- XEP-0343 implementation.
- `file_send` bridge method now use serialised dict as output.
- New `BaseTransportHandler.is_usable` method which get content data and returns a boolean
(default to `True`) to tell if this transport can actually be used in this context (when
we are initiator). Used in webRTC case to see if call data are available.
- Support of `application` media type, and everything necessary to handle data channels.
- Better confirmation message, with file name, size and description when available.
- When file is accepted in preflight, it is specified in following `action_new` signal for
actual file transfer. This way, frontend can avoid the display or 2 confirmation
messages.
- XEP-0166: when not specified, default `content` name is now its index number instead of
a UUID. This follows the behaviour of browsers.
- XEP-0353: better handling of events such as call taken by another device.
- various other updates.
rel 441
author | Goffi <goffi@goffi.org> |
---|---|
date | Sat, 06 Apr 2024 12:57:23 +0200 |
parents | 31c84a32c897 |
children |
rev | line source |
---|---|
3381 | 1 #!/bin/bash |
2 | |
3 # we first need to wait for PostgreSQL | |
4 # cf. https://stackoverflow.com/a/39028690 (thanks!) | |
5 | |
6 RETRIES=5 | |
7 | |
8 until psql -c "select 1" > /dev/null 2>&1 || [ $RETRIES -eq 0 ]; do | |
9 echo "Waiting for postgres server, $((RETRIES--)) remaining attempts…" | |
10 sleep 1 | |
11 done | |
12 | |
13 ori_dir=${PWD} | |
4215 | 14 cd /src/libervia-pubsub/db |
3381 | 15 |
16 # PG should be OK, we now initialize the database. If it's already done, it will fail | |
17 # with exit code 3 | |
18 psql -v ON_ERROR_STOP=1 pubsub < pubsub.sql 2>/dev/null | |
19 case $? in | |
20 0) printf "database initialized\n" ;; | |
21 3) printf "database already exists\n" ;; | |
22 *) printf "can't initialize database, please check PostgreSQL container parameters\n" >&2 | |
23 exit 1 | |
24 ;; | |
25 esac | |
26 | |
27 cd $ori_dir | |
28 | |
3497
73e04040d577
docker: update following name changes:
Goffi <goffi@goffi.org>
parents:
3381
diff
changeset
|
29 exec /home/libervia/libervia_env/bin/twistd -n libervia-pubsub "$@" |